-- 
-- Scrypt do przyczepy PTS 12 by maciusboss1
-- Scrypt by maciusboss1
-- Data: 11.07.2011 r.
-- Zakaz przerabiania i brania do swoich modeli
-- Zapraszam na www.lsmodss.pl


PTS = {};

function PTS.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Trailer, specializations);
end;

function PTS:load(xmlFile)
	self.plandeka1 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.plandeka1#index"));
	self.plandeka = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.plandeka#index"));
	self.plandeka2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.plandeka2#index"));
	
	self.plandeka1Active = true;
	self.plandekaActive = false;
	self.plandeka2Active = true;


	local rotationPartNode = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPart#index"));
    if rotationPartNode ~= nil then
        self.rotationPart = {};
        self.rotationPart.node = rotationPartNode;

	   local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPart#minRot"));
        self.rotationPart.minRot = {};
        self.rotationPart.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPart.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPart.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPart#maxRot"));
        self.rotationPart.maxRot = {};
        self.rotationPart.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPart.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPart.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPart.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPart#rotTime"), 2)*1000;
        self.rotationPart.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPart#touchRotLimit"), 10));
    end;
    
   	local rotationPartNode2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPart2#index"));
    if rotationPartNode2 ~= nil then
        self.rotationPart2 = {};
        self.rotationPart2.node = rotationPartNode2;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPart2#minRot"));
        self.rotationPart2.minRot = {};
        self.rotationPart2.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPart2.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPart2.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPart2#maxRot"));
        self.rotationPart2.maxRot = {};
        self.rotationPart2.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPart2.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPart2.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPart2.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPart2#rotTime"), 2)*1000;
        self.rotationPart2.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPart2#touchRotLimit"), 10));
    end;
    
    local rotationPartNode3 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPart3#index"));
    if rotationPartNode3 ~= nil then
        self.rotationPart3 = {};
        self.rotationPart3.node = rotationPartNode3;

	   local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPart3#minRot"));
        self.rotationPart3.minRot = {};
        self.rotationPart3.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPart3.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPart3.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPart3#maxRot"));
        self.rotationPart3.maxRot = {};
        self.rotationPart3.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPart3.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPart3.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPart3.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPart3#rotTime"), 2)*1000;
        self.rotationPart3.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPart3#touchRotLimit"), 10));
    end;
    
    local rotationPartNode4 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPart4#index"));
    if rotationPartNode4 ~= nil then
        self.rotationPart4 = {};
        self.rotationPart4.node = rotationPartNode4;

	   local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPart4#minRot"));
        self.rotationPart4.minRot = {};
        self.rotationPart4.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPart4.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPart4.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPart4#maxRot"));
        self.rotationPart4.maxRot = {};
        self.rotationPart4.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPart4.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPart4.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPart4.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPart4#rotTime"), 2)*1000;
        self.rotationPart4.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPart4#touchRotLimit"), 10));
    end;

end;

function PTS:delete()
end;

function PTS:mouseEvent(posX, posY, isDown, isUp, button)
end;

function PTS:keyEvent(unicode, sym, modifier, isDown)
    if isDown and sym == Input.KEY_8 then
		self.helpPanel = not self.helpPanel;
	end;

	if isDown and sym == Input.KEY_m then
	    self.rotationMax = not self.rotationMax;
	   	end;
	if isDown and sym == Input.KEY_n then
	    self.rotationMax2 = not self.rotationMax2;
	   	end;
	if isDown and sym == Input.KEY_j then
	    self.rotationMax3 = not self.rotationMax3;
	   	end;
	if isDown and sym == Input.KEY_k then
	    self.rotationMax4 = not self.rotationMax4;
	   	end;
	if isDown and sym == Input.KEY_KP_0 then
		self.plandeka2Active = not self.plandeka2Active;
	end;
	if isDown and sym == Input.KEY_v then
		self.plandekaActive = not self.plandekaActive;
		self.plandeka1Active = not self.plandeka1Active;
	end;
end;

function PTS:update(dt)
	
	self.isExpanded = false;
	setVisibility(self.plandeka1, self.plandeka1Active);
	setVisibility(self.plandeka2, self.plandeka2Active);
	setVisibility(self.plandeka, self.plandekaActive);
	if self.rotationPart ~= nil then
		local x, y, z = getRotation(self.rotationPart.node);
		local maxRot = self.rotationPart.maxRot;
		local eps = self.rotationPart.touchRotLimit
			
		if math.abs(x-maxRot[1]) < eps and math.abs(y-maxRot[2]) < eps and math.abs(z-maxRot[3]) < eps then
            self.isExpanded = true;
        end;
	end;
	if self.rotationPart ~= nil then
		local x, y, z = getRotation(self.rotationPart.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.rotationPart.maxRot, self.rotationPart.minRot, 3, self.rotationPart.rotTime, dt, not self.rotationMax);
		setRotation(self.rotationPart.node, unpack(newRot));
	end;
	if self.rotationPart2 ~= nil then
		local x, y, z = getRotation(self.rotationPart2.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.rotationPart2.maxRot, self.rotationPart2.minRot, 3, self.rotationPart2.rotTime, dt, not self.rotationMax2);
		setRotation(self.rotationPart2.node, unpack(newRot));
	end;
	if self.rotationPart3 ~= nil then
		local x, y, z = getRotation(self.rotationPart3.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.rotationPart3.maxRot, self.rotationPart3.minRot, 3, self.rotationPart3.rotTime, dt, not self.rotationMax3);
		setRotation(self.rotationPart3.node, unpack(newRot));
	end;
	if self.rotationPart4 ~= nil then
		local x, y, z = getRotation(self.rotationPart4.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.rotationPart4.maxRot, self.rotationPart4.minRot, 3, self.rotationPart4.rotTime, dt, not self.rotationMax4);
		setRotation(self.rotationPart4.node, unpack(newRot));
	end;



end;

function PTS:draw()
        
	if self.helpPanel then
           g_currentMission:addExtraPrintText("Wcisnij 8: Wlacz Info Przyczepa PTS 12");
    else
          g_currentMission:addExtraPrintText("Wcisnij 8: Wylacz Info Przyczepa PTS 12");
    end;
	if self.helpPanel then
			renderText(0.65, 0.67, 0.025, "-Przyczepa PTS 12- By Maciusboss1");
			renderText(0.65, 0.645, 0.02, "Wcisnij: N/J: otworz/zamknij burty lewe");
			renderText(0.65, 0.63, 0.02, "Wcisnij: M/K: otworz/zamknij burty prawe");
			renderText(0.65, 0.615, 0.02, "Wcisnij NUM 1|3/2: Kierunkowskazy/awaryjne");
			renderText(0.65, 0.6, 0.02, "Wcisnij V: zaloz/sciagnij plandeke");
			renderText(0.65, 0.585, 0.02, "Wcisnij NUM 0: usu plandeke");
		end;


end;


function PTS:onAttach()
	
end;

function PTS:onDetach()
end;

function PTS:onLeave()
end;